//=============================================================================
// Deagle Fire
//=============================================================================
class DeagleFire extends KFFire;

var float ClickTime;



function Recoil()
{
    local Rotator NewRotation;
    local float NewPitch, NewYaw;

    if ( (Instigator != None) && Instigator.IsFirstPerson()){
    NewPitch = int(Frand()*300); NewYaw = int(Frand()*550);
    if (Frand() > 0.5) NewYaw *= -1;
    if (Frand() > 0.5) NewPitch *= -1;
    NewRotation = Instigator.GetViewRotation();
    NewRotation.Pitch += NewPitch;
    NewRotation.Yaw += NewYaw;
    Instigator.SetViewRotation(NewRotation);}
}

//event ModeDoFire()
//{
//	if ( Level.TimeSeconds - LastFireTime > 0.5 )
//		Spread = Default.Spread;
//	else
//		Spread = FMin(Spread+0.02,0.12);
//	LastFireTime = Level.TimeSeconds;
//	Recoil();
//    Super.ModeDoFire();
//}

simulated function bool AllowFire()
{



    if (Super.AllowFire())
        return true;
    else
    {
        if ( (PlayerController(Instigator.Controller) != None) && (Level.TimeSeconds > ClickTime) )
        {
            Instigator.PlaySound(Sound'WeaponSounds.P1Reload5');
			ClickTime = Level.TimeSeconds + 0.25;
		}
        return false;

    }
}



defaultproperties
{
     DamageType=Class'KFmod.DamTypeDeagle'
     DamageMin=80
     DamageMax=110
     Momentum=+30000.0
     bPawnRapidFireAnim=True
     bWaitForRelease=True
     bAttachSmokeEmitter=True
     FireLoopAnim=
     FireEndAnim=
     FireSound=Sound'KFWeaponSound.Deagle-Fire'
     FireForce="ShockRifleFire"
     FireRate=0.40000
     AmmoClass=Class'KFmod.DeagleAmmo'
     AmmoPerFire=1
     ShakeRotMag=(X=100.000000,Y=100.000000,Z=100.000000)
     ShakeRotRate=(X=10000.000000,Y=10000.000000,Z=10000.000000)
     ShakeRotTime=2.000000
     ShakeOffsetMag=(X=2.000000,Y=2.000000,Z=2.000000)
     ShakeOffsetRate=(X=1000.000000,Y=1000.000000,Z=1000.000000)
     ShakeOffsetTime=2.000000
     BotRefireRate=0.650000
     FlashEmitterClass=class'KFMod.L85MuzzFlash'
     aimerror=40.000000
     SpreadStyle=SS_Random
     TransientSoundVolume=+100

}
