//=============================================================================
// KFPawn
//=============================================================================
class KFPawn extends xPawn;

var string KFBSkin;
var string KFFSkin;
var mesh  KFSMesh;

simulated function DoDerezEffect()
{
    // fuck no!
}

function DoDamageFX( Name boneName, int Damage, class<DamageType> DamageType, Rotator r )
{
    local float DismemberProbability;
    local bool bExtraGib;

    if ( FRand() > 0.3f || Damage > 30 || Health <= 0 )
    {
        HitFX[HitFxTicker].damtype = DamageType;

        if( Health <= 0 )
        {
            switch( boneName )
            {
                case 'Bip01 L Foot':
                    boneName = 'Bip01 L Thigh';
                    break;

                case 'Bip01 R Foot':
                    boneName = 'Bip01 R Thigh';
                    break;

                case 'Bip01 R Hand':
                    boneName = 'rfarm';
                    break;

                case 'Bip01 L Hand':
                    boneName = 'Bip01 L Forearm';
                    break;

                case 'Bip01 R Clavicle':
                case 'Bip01 L Clavicle':
                    boneName = 'Bip01 Spine';
                    break;
            }

            if( DamageType.default.bAlwaysSevers || (Damage == 1000) )
            {
                HitFX[HitFxTicker].bSever = true;
                if ( boneName == 'None' )
                {
                    boneName = 'Bip01 R Forearm';
                    bExtraGib = true;
                }
            }
                  else if( (Damage*DamageType.Default.GibModifier > 50+120*FRand()-9999999999) && (Damage >= 0) ) // total gib prob
            {
                HitFX[HitFxTicker].bSever = true;
                boneName = 'Bip01 R Forearm';
                bExtraGib = true;
            }
            else
            {
                DismemberProbability = Abs( (Health - Damage*DamageType.Default.GibModifier) / 130.0f );
                switch( boneName )
                {
                    case 'Bip01 L Thigh':
                    case 'Bip01 R Thigh':
                    case 'Bip01 R Forearm':
                    case 'Bip01 L Forearm':
                    case 'Bip01 Head':
                        if( FRand() < DismemberProbability )
                            HitFX[HitFxTicker].bSever = true;
                        break;

                    case 'Bip01 Head':
                        boneName = 'Bip01 Head';
                     case 'Bip01 Head':
                        if( FRand() < DismemberProbability * 0.3 )
                        {
                            HitFX[HitFxTicker].bSever = true;
                            if ( FRand() < 0.65 )
                                bExtraGib = true;
                        }
                        break;
                }
            }
        }

        if ( DamageType.default.bNeverSevers || class'GameInfo'.static.UseLowGore()
         || (Level.Game != None && Level.Game.PreventSever(self, boneName, Damage, DamageType)) )
        {
        HitFX[HitFxTicker].bSever = false;
        bExtraGib = false;
    }

        HitFX[HitFxTicker].bone = boneName;
        HitFX[HitFxTicker].rotDir = r;
        HitFxTicker = HitFxTicker + 1;
        if( HitFxTicker > ArrayCount(HitFX)-1 )
            HitFxTicker = 0;
        if ( bExtraGib )
        {
        if ( FRand() < 0.25 )
        {
            DoDamageFX('Bip01 L Forearm',1000,DamageType,r);
            DoDamageFX('Bip01 R Forearm',1000,DamageType,r);
        }
        else if ( FRand() < 0.35 )
            DoDamageFX('Bip01 L Thigh',1000,DamageType,r);
        else if ( FRand() < 0.5 )
            DoDamageFX('Bip01 Head',1000,DamageType,r);

        else
         DoDamageFX('Bip01 Head',1000,DamageType,r);
    }
    }
}




//Stops the green shit when a player dies.
simulated function PlayDying(class<DamageType> DamageType, vector HitLoc)
{
	local float frame, rate;
    local name seq;
	local LavaDeath LD;
	local MiscEmmiter BE;

	AmbientSound = None;
    bCanTeleport = false; // sjs - fix karma going crazy when corpses land on teleporters
    bReplicateMovement = false;
    bTearOff = true;
    bPlayedDeath = true;

    if (CurrentCombo != None)
        CurrentCombo.Destroy();

	HitDamageType = DamageType; // these are replicated to other clients
    TakeHitLocation = HitLoc;

    if ( DamageType != None )
    {
		if ( DamageType.default.bSkeletize )
		{
			SetOverlayMaterial(DamageType.Default.DamageOverlayMaterial, 4.0, true);
			if (!bSkeletized)
			{
				if ( (Level.NetMode != NM_DedicatedServer) && (SkeletonMesh != None) )
				{
					if ( DamageType.default.bLeaveBodyEffect )
					{
						BE = spawn(class'MiscEmmiter',self);
						if ( BE != None )
						{
							BE.DamageType = DamageType;
							BE.HitLoc = HitLoc;
							bFrozenBody = true;
						}
					}
					GetAnimParams( 0, seq, frame, rate );
					LinkMesh(SkeletonMesh, true);
					Skins.Length = 0;
					PlayAnim(seq, 0, 0);
					SetAnimFrame(frame);
				}
				if (Physics == PHYS_Walking)
					Velocity = Vect(0,0,0);
				TearOffMomentum *= 0.25;
				bSkeletized = true;
				if ( (Level.NetMode != NM_DedicatedServer) && (DamageType == class'FellLava') )
				{
					LD = spawn(class'LavaDeath', , , Location + vect(0, 0, 10), Rotation );
					if ( LD != None )
						LD.SetBase(self);
					PlaySound( sound'WeaponSounds.BExplosion5', SLOT_None, 1.5*TransientSoundVolume );
				}
			}
		}
		else if ( DamageType.Default.DeathOverlayMaterial != None )
			SetOverlayMaterial(DamageType.Default.DeathOverlayMaterial, DamageType.default.DeathOverlayTime, true);
		else if ( (DamageType.Default.DamageOverlayMaterial != None) && (Level.DetailMode != DM_Low) && !Level.bDropDetail )
			SetOverlayMaterial(DamageType.Default.DamageOverlayMaterial, 2*DamageType.default.DamageOverlayTime, true);
	}

    // stop shooting
    AnimBlendParams(1, 0.0);
    FireState = FS_None;
	LifeSpan = RagdollLifeSpan;

    GotoState('Dying');
    if ( BE != None )
		return;

	PlayDyingAnimation(DamageType, HitLoc);
}

simulated function bool ForceDefaultCharacter()
{
return false;
}

  simulated function Timer()
    {
        local KarmaParamsSkel skelParams;

        if ( !PlayerCanSeeMe() )
        {
            Destroy();
        }
        // If we are running out of life, bute we still haven't come to rest, force the de-res.
        // unless pawn is the viewtarget of a player who used to own it
        else if ( LifeSpan <= DeResTime && bDeRes == false )
        {
            skelParams = KarmaParamsSkel(KParams);

            // check not viewtarget
            if ( (PlayerController(OldController) != None) && (PlayerController(OldController).ViewTarget == self)
                && (Viewport(PlayerController(OldController).Player) != None) )
            {
                skelParams.bKImportantRagdoll = true;
                LifeSpan = FMax(LifeSpan,DeResTime + 2.0);
                SetTimer(1.0, false);
                return;
            }
            else
            {
                skelParams.bKImportantRagdoll = false;
            }


    }

}


 simulated function ProcessHitFX()
{
    local Coords boneCoords;
    local class<xEmitter> HitEffects[4];
    local int i,j;
    local float GibPerterbation;

    if( (Level.NetMode == NM_DedicatedServer) || bSkeletized || (Mesh == SkeletonMesh) )
    {
        SimHitFxTicker = HitFxTicker;
        return;
    }

    for ( SimHitFxTicker = SimHitFxTicker; SimHitFxTicker != HitFxTicker; SimHitFxTicker = (SimHitFxTicker + 1) % ArrayCount(HitFX) )
    {
        j++;
        if ( j > 30 )
        {
            SimHitFxTicker = HitFxTicker;
            return;
        }

        if( (HitFX[SimHitFxTicker].damtype == None) || (Level.bDropDetail && (Level.TimeSeconds - LastRenderTime > 3) && !IsHumanControlled()) )
            continue;

        boneCoords = GetBoneCoords( HitFX[SimHitFxTicker].bone );

        if ( !Level.bDropDetail && !bSkeletized )
        {
            AttachEffect( GibGroupClass.static.GetBloodEmitClass(), HitFX[SimHitFxTicker].bone, boneCoords.Origin, HitFX[SimHitFxTicker].rotDir );

            HitFX[SimHitFxTicker].damtype.static.GetHitEffects( HitEffects, Health );

            if( !PhysicsVolume.bWaterVolume ) // don't attach effects under water
            {
                for( i = 0; i < ArrayCount(HitEffects); i++ )
                {
                    if( HitEffects[i] == None )
                        continue;

                    AttachEffect( HitEffects[i], HitFX[SimHitFxTicker].bone, boneCoords.Origin, HitFX[SimHitFxTicker].rotDir );
                }
            }
        }
        if ( class'GameInfo'.static.UseLowGore() )
            HitFX[SimHitFxTicker].bSever = false;

        if( HitFX[SimHitFxTicker].bSever )
        {
            GibPerterbation = HitFX[SimHitFxTicker].damtype.default.GibPerterbation;
            bFlaming = HitFX[SimHitFxTicker].DamType.Default.bFlaming;

            switch( HitFX[SimHitFxTicker].bone )
            {
                case 'Bip01 L Thigh':
                case 'Bip01 R Thigh':
                    SpawnGiblet( GetGibClass(EGT_Calf), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                    SpawnGiblet( GetGibClass(EGT_Calf), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                    GibCountCalf -= 2;
                    break;

                case 'Bip01 R Forearm':
                case 'Bip01 L Forearm':
                    SpawnGiblet( GetGibClass(EGT_UpperArm), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                    SpawnGiblet( GetGibClass(EGT_Forearm), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                    GibCountForearm--;
                    GibCountUpperArm--;
                    break;

                case 'Bip01 Head':
                    SpawnGiblet( GetGibClass(EGT_Head), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                    GibCountTorso--;
                    break;

                case 'Bip01 Spine':
                case 'Bip01 Spine':
                    SpawnGiblet( GetGibClass(EGT_Torso), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                    GibCountTorso--;
                    bGibbed = true;
                    while( GibCountHead-- > 0 )
                        SpawnGiblet( GetGibClass(EGT_Head), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                    while( GibCountForearm-- > 0 )
                        SpawnGiblet( GetGibClass(EGT_UpperArm), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                    while( GibCountUpperArm-- > 0 )
                        SpawnGiblet( GetGibClass(EGT_Forearm), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                    if ( !bFlaming && !Level.bDropDetail && (Level.DetailMode != DM_Low) && PlayerCanSeeMe() )
                    {
                        // extra gibs!!!
                        GibPerterbation = FMin(1.0, 1.5 * GibPerterbation);
                        SpawnGiblet( GetGibClass(EGT_Calf), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                        SpawnGiblet( GetGibClass(EGT_Calf), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                        SpawnGiblet( GetGibClass(EGT_UpperArm), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                        SpawnGiblet( GetGibClass(EGT_Forearm), boneCoords.Origin, HitFX[SimHitFxTicker].rotDir, GibPerterbation );
                    }
                    break;
            }

            HideBone(HitFX[SimHitFxTicker].bone);
        }
    }
}



simulated function StopFiring()
{
    if (FireState == FS_Looping)
    {
        FireState = FS_PlayOnce;
    }
    IdleTime = Level.TimeSeconds;
}




simulated function StartDeRes()
{
    if( Level.NetMode == NM_DedicatedServer )
        return;

    AmbientGlow=0;
    MaxLights=5;

   // DeResFX = Spawn(class'DeResPart', self, , Location);

    //Skins[0] = DeResMat0;
    //Skins[1] = DeResMat1;

    if( Physics == PHYS_KarmaRagdoll )
    {

    // Remove flames
    RemoveFlamingEffects();

    // Turn off any overlays
    SetOverlayMaterial(None, 0.0f, true);


  }

}




// Remove Shield Sounds , Randomize for Human Pain sound.

function int ShieldAbsorb( int dam )
{
    local float Interval, damage, Remaining;
    local int PainSound;

    damage = dam;

    if ( ShieldStrength == 0 )
    {
        return damage;
    }
    //SetOverlayMaterial( ShieldHitMat, ShieldHitMatTime, false );

    // Randomize Painsounds on Armor hit

    PainSound = rand(6);

    if (PainSound == 0)
    {
      PlaySound(sound'KFPlayerSound.hpain3', SLOT_Pain,2*TransientSoundVolume,,400);
    }


    if (PainSound == 1)
    {
      PlaySound(sound'KFPlayerSound.hpain2', SLOT_Pain,2*TransientSoundVolume,,400);
    }


    if (PainSound == 2)
    {
      PlaySound(sound'KFPlayerSound.hpain1', SLOT_Pain,2*TransientSoundVolume,,400);
    }


    if (PainSound == 3)
    {
      PlaySound(sound'KFPlayerSound.hpain3', SLOT_Pain,2*TransientSoundVolume,,400);
    }


    if (PainSound == 4)
    {
      PlaySound(sound'KFPlayerSound.hpain2', SLOT_Pain,2*TransientSoundVolume,,400);
    }


    if (PainSound == 5)
    {
      PlaySound(sound'KFPlayerSound.hpain1', SLOT_Pain,2*TransientSoundVolume,,400);
    }


    if ( ShieldStrength > 100 )
    {
        Interval = ShieldStrength - 100;
        if ( Interval >= damage )
        {
            ShieldStrength -= damage;
            return 0;
        }
        else
        {
            ShieldStrength = 100;
            damage -= Interval;
        }
    }
    if ( ShieldStrength > SmallShieldStrength )
    {
        Interval = ShieldStrength - SmallShieldStrength;
        if ( Interval >= 0.75 * damage )
        {
            ShieldStrength -= 0.75 * damage;
            if ( ShieldStrength < SmallShieldStrength )
                SmallShieldStrength = ShieldStrength;
            return (0.25 * Damage);
        }
        else
        {
            ShieldStrength = SmallShieldStrength;
            damage -= Interval;
            Remaining = 0.33 * Interval;
            if ( Remaining <= damage )
                return damage;
            damage -= Remaining;
        }
    }
    if ( ShieldStrength >= 0.5 * damage )
    {
        ShieldStrength -= 0.5 * damage;
        SmallShieldStrength = ShieldStrength;
        return Remaining + (0.5 * damage);
    }
    else
    {
        damage -= ShieldStrength;
        ShieldStrength = 0;
        SmallShieldStrength = 0;
    }
    return damage + Remaining;
}



simulated function StartFiring(bool bHeavy, bool bRapid)
{
    if(Weapon.IsA('KFMeleeGun'))
    {
        if(KFMeleeGun(Weapon).TPAnim == '')
        {
            Super.StartFiring(bHeavy,bRapid);
            return;
        }
        if ( HasUDamage() && (Level.TimeSeconds - LastUDamageSoundTime > 0.25) )
        {
            LastUDamageSoundTime = Level.TimeSeconds;
            PlaySound(UDamageSound, SLOT_None, 1.5*TransientSoundVolume,,700);
        }

        if (Physics == PHYS_Swimming)
            return;

        AnimBlendParams(1, 1.0, 0.0, 0.2, FireRootBone);

        PlayAnim(KFMeleeGun(Weapon).TPAnim,, 0.0, 1);
        FireState = FS_PlayOnce;
        IdleTime = Level.TimeSeconds;
        return;
    } else if(Weapon.IsA('KFWeapon'))
    {
        if(KFWeapon(Weapon).TPAnim == '')
        {
            Super.StartFiring(bHeavy,bRapid);
            return;
        }

        if ( HasUDamage() && (Level.TimeSeconds - LastUDamageSoundTime > 0.25) )
        {
            LastUDamageSoundTime = Level.TimeSeconds;
            PlaySound(UDamageSound, SLOT_None, 1.5*TransientSoundVolume,,700);
        }

        if (Physics == PHYS_Swimming)
            return;

        AnimBlendParams(1, 1.0, 0.0, 0.2, FireRootBone);

        if (bRapid)
        {
            if (FireState != FS_Looping)
            {
                LoopAnim(KFWeapon(Weapon).TPAnim,, 0.0, 1);
                FireState = FS_Looping;
            }
        }
        else
        {
            PlayAnim(KFWeapon(Weapon).TPAnim,, 0.0, 1);
            FireState = FS_PlayOnce;
        }

        IdleTime = Level.TimeSeconds;
        return;
    } else
        Super.StartFiring(bHeavy,bRapid);
}

defaultproperties
{

        Begin Object Class=KarmaParamsSkel Name=PawnKParams
        KFriction=0.9
        KRestitution=0.1
        KAngularDamping=0.05
        KLinearDamping=0.15
        KBuoyancy=1
        KStartEnabled=True
        KImpactThreshold=500
        KVelDropBelowThreshold=100
        KConvulseSpacing=(Min=0.5,Max=2.2)
        bHighDetailOnly=False
        Name="PawnKParams"
    End Object


    RagInvInertia=4
    RagShootStrength=6000
    RagSpinScale=2.5
    RagDeathUpKick=100
    RagGravScale=1.0


     GibGroupClass=Class'KFmod.KFGibGroup'
     SoundGroupClass=Class'KFmod.KFMaleSoundGroup'
     TeleportFXClass=none
     DeResTime=0.000000
     DeResMat0= Material 'KFCharacters.KFDeRez'
     DeResMat1= Material 'KFCharacters.KFDeRez'
     DeResLiftVel=(Points=(,(InVal=0.000000,OutVal=0.000000),(InVal=0.000000,OutVal=0.000000)))
     DeResLiftSoftness=(Points=((OutVal=0.000000),(InVal=0.000000,OutVal=0.000000),(InVal=0.000000,OutVal=0.000000)))
     DeResLateralFriction=0.000000
     RagdollLifeSpan=5.000000
     RagDeathVel=75.000000
     RequiredEquipment(0)="none"
     RequiredEquipment(1)="none"
     GroundSpeed=240.000000
     WaterSpeed=180.000000
     AirSpeed=240.000000
     JumpZ=300.000000
     ShieldHitMat=none
     BaseEyeHeight=54.000000
     EyeHeight=54.000000
     AmbientGlow=0
     CollisionRadius=26.000000
     CollisionHeight=40.000000
     DodgeSpeedFactor=1
     DodgeSpeedZ=0.0
     FootstepVolume=1
     TransOutEffect(0)=none
    TransOutEffect(1)=none
    TransEffects(0)=none
    TransEffects(1)=none
    Mass = 1000
    ShieldStrengthMax=100.0

}
