class Claws extends KFMeleeGun;

#exec OBJ LOAD FILE=KillingFloorWeapons.utx
#exec OBJ LOAD FILE=KillingFloorHUD.utx

var() Material ZoomMat;
var() bool zoomed;
var transient float LastFOV;
var color ChargeColor;
var() float HealRate;
var transient float HealAccum;


simulated function Tick(float dt)
{
    if ( (Level.NetMode == NM_Client) || Instigator == None || Instigator.PlayerReplicationInfo == None)
        return;
    if(Instigator.Weapon == self && Instigator.Health < Instigator.HealthMax)
    {
        HealAccum += HealRate*dt;
        if(HealAccum > 1)
        {
            Instigator.Health = Min(Instigator.HealthMax, Instigator.Health+HealAccum);

             HealAccum -= int(HealAccum);
        }
    }
}



function bool CanAttack(Actor Other)
{

local float enemyDist;
local Bot B;

B = Bot(Instigator.Controller);
enemyDist = VSize(B.Enemy.Location - Instigator.Location);

    if (enemyDist < 110 )
    {
        return true;
    }

    else

      return false;

}



//simulated event RenderOverlays(Canvas Canvas)
//{
//	local PlayerController PC;
 //
//	PC = PlayerController(Instigator.Controller);

//	if(PC == None)
//		return;

//	if(LastFOV != PC.DesiredFOV)
//	   //Blah blah

//	LastFOV = PC.DesiredFOV;

//	if (PC.DesiredFOV == PC.DefaultFOV || (Level.bClassicView && PC.DesiredFOV == 90))
//	{
//		Super.RenderOverlays(Canvas);
//		zoomed=false;
//	}
//	else
//	{

		//Black-out either side of the main zoom circle.
//		Canvas.Style = ERenderStyle.STY_Normal;
//		Canvas.SetPos(0, 0);
//		Canvas.DrawTile(Texture'KillingFloorHUD.RedEyesSource', (Canvas.SizeX - Canvas.SizeY) / 2, Canvas.SizeY, 0.0, 0.0, 8, 8);
//		Canvas.SetPos(Canvas.SizeX, 0);
//		Canvas.DrawTile(Texture'KillingFloorHUD.RedEyesSource', -(Canvas.SizeX - Canvas.SizeY) / 2, Canvas.SizeY, 0.0, 0.0, 8, 8);

//		//The view through the scope itself.
//		Canvas.Style = 255;
//		Canvas.SetPos((Canvas.SizeX - Canvas.SizeY) / 2,0);
//		Canvas.DrawTile(ZoomMat, Canvas.SizeY, Canvas.SizeY, 0.0, 0.0, 512, 512);


 //       zoomed = true;
//	}
//}



//function RegenHealthZombie( float dt )
//{
//   if (Pawn(Other) != None && Pawn(Other).Health < Pawn(Other).HealthMax*2 )
//        {
//            Pawn(Other).Health = Min( Pawn(Other).Health+RegenPerSecond, Pawn(Other).HealthMax*2 );
//        }
//}



defaultproperties
{
     HighDetailOverlay= none
     ZoomMat=Texture'KillingFloorHUD.RedEyesSource'
     FireModeClass(0)=Class'KFmod.ClawsFire'
     FireModeClass(1)=Class'KFmod.ClawsFire2'
     SelectForce="SwitchToFlakCannon"
     AIRating=0.450000
     CurrentRating=0.250000
     bCanThrow=False
     Description="Bloody and Sharp. Yikes! "
     EffectOffset=(X=100.000000,Y=32.000000,Z=-20.000000)
     HudColor=(G=0)
     SmallViewOffset=(X=13.000000,Y=12.000000,Z=-10.000000)
     CenteredOffsetY=-5.000000
     CenteredRoll=3000
     DisplayFOV=80.0
     CenteredYaw=-1500
     GroupOffset=2
     PickupClass=Class'KFmod.ClawsPickup'
     PlayerViewOffset=(X=4.000000,Y=7.500000,Z=-6.000000)
     PlayerViewPivot=(Pitch=400)
     BobDamping=7.000000
     AttachmentClass=Class'KFmod.ClawsAttachment'
     IconMaterial=Texture'KillingFloorHUD.Generic.HUD'
     IconCoords=(X1=169,Y1=78,X2=244,Y2=124)
     ItemName="Claws"
     Mesh=SkeletalMesh'KFWeaponModels.Claws'

    OldCenteredOffsetY=-10.0
    OldCenteredRoll=2000
    OldCenteredYaw=0
    OldDrawScale=+1.0
    HealRate = 3

}
