class ClawsFire extends KFMeleeFire;

var float ZoomLevel;

function float MaxRange()
{
    if (Instigator.Region.Zone.bDistanceFog)
        TraceRange = FClamp(Instigator.Region.Zone.DistanceFogEnd, 125, default.TraceRange);
    else
        TraceRange = default.TraceRange;

    return TraceRange;
}

function ModeTick(float deltaTime)
{
  local PlayerController C;
  ZoomLevel += deltaTime;
  if (ZoomLevel > 0.10)
    ZoomLevel = 0.10;
  C = PlayerController(Instigator.Controller);
  if(C != None)
    C.DesiredFOV = FClamp(90.0 - (ZoomLevel * 88.0), 1, 170);
}

simulated function vector GetFireStart(vector X, vector Y, vector Z)
{
    return Instigator.Location;
}

function StartBerserk()
{
}

function StopBerserk()
{
}

function StartSuperBerserk()
{
}

defaultproperties
{
     ShieldRange=125.000000
     MinForce=.200000
     MaxForce=.500000
     MinDamage=40.000000
     MaxDamage=60.000000
     SelfForceScale=0.000000
     SelfDamageScale=0.000000
     MinSelfDamage=0.000000
     ChargingSoundVolume=0
     bFireOnRelease=False
     FireSound=Sound'KFWeaponSound.ZombieChop'
     FireRate=.700000
     DamageType=Class'KFmod.DamTypeClaws'
     AimError=0
     BotRefireRate=.7
}
