//=============================================================================
// Dualies Fire
//=============================================================================
class DualiesFire extends KFFire;

var float ClickTime;
var name FireAnim2;

function Recoil()
{
    local Rotator NewRotation;
    local float NewPitch, NewYaw;

    if ( (Instigator != None) && Instigator.IsFirstPerson()){
    NewPitch = int(Frand()*300); NewYaw = int(Frand()*550);
    if (Frand() > 0.5) NewYaw *= -1;
    if (Frand() > 0.5) NewPitch *= -1;
    NewRotation = Instigator.GetViewRotation();
    NewRotation.Pitch += NewPitch;
    NewRotation.Yaw += NewYaw;
    Instigator.SetViewRotation(NewRotation);}
}

event ModeDoFire()
{
    local name fa;
    local name bn;
    local name tpa;
    bn = Dualies(Weapon).altFlashBoneName;
    Dualies(Weapon).altFlashBoneName = Dualies(Weapon).FlashBoneName;
    Dualies(Weapon).FlashBoneName = bn;
    InitEffects();

    Super.ModeDoFire();

    fa = FireAnim2;
    FireAnim2 = FireAnim;
    FireAnim = fa;

    tpa = Dualies(Weapon).altTPAnim;
    Dualies(Weapon).TPAnim = Dualies(Weapon).altTPAnim;
    Dualies(Weapon).altTPAnim = tpa;
}

function StartBerserk()
{
    DamageMin = default.DamageMin * 1.33;
    DamageMax = default.DamageMax * 1.33;
}

function StopBerserk()
{
    DamageMin = default.DamageMin;
    DamageMax = default.DamageMax;
}

function StartSuperBerserk()
{
    FireRate = default.FireRate * 1.5/Level.GRI.WeaponBerserk;
    FireAnimRate = default.FireAnimRate * 0.667 * Level.GRI.WeaponBerserk;
    DamageMin = default.DamageMin * 1.5;
    DamageMax = default.DamageMax * 1.5;
    if (AssaultRifle(Weapon) != None && AssaultRifle(Weapon).bDualMode)
    	FireRate *= 0.55;
}

defaultproperties
{
     DamageType=Class'KFmod.DamTypeDeagle'
     DamageMin=30
     DamageMax=45
     Momentum=+10000.0
     bPawnRapidFireAnim=True
     bWaitForRelease=False
     bAttachSmokeEmitter=True
     FireLoopAnim=
     FireEndAnim=
     FireAnim=FireRight
     FireAnim2=FireLeft
     FireSound=Sound'KFWeaponSound.DualiesFire'
     FireForce="AssaultRifleFire"
     FireRate=0.350000
     AmmoClass=Class'KFmod.DualiesAmmo'
     AmmoPerFire=2
     ShakeRotMag=(X=50.000000,Y=50.000000,Z=50.000000)
     ShakeRotRate=(X=10000.000000,Y=10000.000000,Z=10000.000000)
     ShakeRotTime=2.000000
     ShakeOffsetMag=(X=1.000000,Y=1.000000,Z=1.000000)
     ShakeOffsetRate=(X=1000.000000,Y=1000.000000,Z=1000.000000)
     ShakeOffsetTime=2.000000
     BotRefireRate=0.350000
     FlashEmitterClass=class'KFMod.L85MuzzFlash'
     aimerror=30.000000
     Spread=0.015000
     SpreadStyle=SS_Random
}
