//=============================================================================
// Frag Grenade Inventory class
//=============================================================================
class Frag extends KFWeapon;

function float GetAIRating()
{
	local Bot B;


	B = Bot(Instigator.Controller);
	if ( (B == None) || (B.Enemy == None) )
		return AIRating;

	return (AIRating + 0.0003 * FClamp(1500 - VSize(B.Enemy.Location - Instigator.Location),0,1000));
}

function byte BestMode()
{
    return 0;
}

defaultproperties
{
     ClipCount=1
     ReloadRate=1.000000
     ReloadBeginSound=Sound'KFWeaponSound.DeagleClipout'
     ReloadSound=Sound'KFWeaponSound.DeagleClipin'
     ReloadAnim="Reload"
     ReloadAnimRate=1.000000
     FireModeClass(0)=Class'KFmod.FragFire'
     FireModeClass(1)=class'KFmod.NoFire'
     bShowChargingBar=True
     Description="Boom"
     Priority=37
     InventoryGroup=2
     PickupClass=Class'KFmod.FragPickup'
     BobDamping=10.000000
     AttachmentClass=Class'KFmod.DeagleAttachment'
     IconCoords=(X1=250,Y1=110,X2=330,Y2=145)
     ItemName="Frag Grenade"
     Mesh=SkeletalMesh'KFWeaponModels.Frag'
     TransientSoundVolume=1.000000
     TransientSoundRadius=700.000000
     TPAnim=NadeToss
}
